#include <eel.h>

shadow eel_group_id {
  int has_events = 0;
  int deleted = 0;
}


event {
  pattern { $1 = eel_new_group_id(); }
  action  { $1->has_events = 0; $1->deleted = 0; }
}
event {
  pattern { eel_delete_group_id($1); }
  action  { $1->has_events = 0; $1->deleted = 1; }
}
event {
  pattern { eel_remove_events($1); }
  action  { $1->has_events = 0; }
}
event {
  after
  pattern { $1 = eel_has_events($2); }
  action  { $1 = $2->has_events; }
}


event {
  pattern { eel_add_timer($1,$?,$?,$?); }
  action  { $1->has_events = 1; }
}
event {
  pattern { eel_add_read($1,$?,$?,$?); }
  action  { $1->has_events = 1; }
}
event {
  pattern { eel_add_write($1,$?,$?,$?); }
  action  { $1->has_events = 1; }
}
event {
  pattern { eel_add_error($1,$?,$?,$?); }
  action  { $1->has_events = 1; }
}
event {
  pattern { eel_add_read_timeout($1,$?,$?,$?,$?,$?); }
  action  { $1->has_events = 1; }
}
event {
  pattern { eel_add_write_timeout($1,$?,$?,$?,$?,$?); }
  action  { $1->has_events = 1; }
}
event {
  pattern { eel_add_error_timeout($1,$?,$?,$?,$?,$?); }
  action  { $1->has_events = 1; }
}


event {
  after
  pattern { check_gid_properties__SCG($1); }
  guard   { $1->has_events == 1 || $1->deleted == 1 }
}
